import os
class BankAccount():

    def __init__(self):
      self.account_number = 0;
      self.pin_number = ""
      self.balance = 0
      self.interest_rate = 0.0
      self.transaction_list = []
      # '''Constructor to set account_number to '0', pin_number to an empty string,
      #      balance to 0.0, interest_rate to 0.0 and transaction_list to an empty list.'''
        

    def deposit_funds(self, amount):
      try:
        amt = float(amount)
        return True
      except:
        return False
        # '''Function to deposit an amount to the account balance. Raises an
        #    exception if it receives a value that cannot be cast to float.'''
        

    def withdraw_funds(self, amount):
      try:
        amt = float(amount)
        if(self.balance >= amt):
          return True
        else:
          return False
      except:
        return False      
        '''Function to withdraw an amount from the account balance. Raises an
           exception if it receives a value that cannot be cast to float. Raises
           an exception if the amount to withdraw is greater than the available
           funds in the account.'''
        
        
    def get_transaction_string(self):
      transaction_str = ""
      for t in self.transaction_list:
        if(t >= 0):
          transaction_str = transaction_str + "Deposit\n"
          transaction_str = transaction_str + str(abs(t)) + "\n"
        else:
          transaction_str = transaction_str + "Withdrawal\n"
          transaction_str = transaction_str + str(abs(t)) + "\n"
      return transaction_str          
        # '''Function to create and return a string of the transaction list. Each transaction
        #    consists of two lines - either the word "Deposit" or "Withdrawal" on
        #    the first line, and then the amount deposited or withdrawn on the next line.'''


    def save_to_file(self):
      filename = str(self.account_number) + ".txt";
      os.remove(filename);
      f = open(filename,'w')
      f.write(str(self.account_number) + "\n")
      f.write(str(self.pin_number)+ "\n")
      f.write(str(self.balance)+ "\n")
      f.write(str(self.interest_rate)+ "\n")
      transaction_str = self.get_transaction_string()
      f.write(transaction_str)
        # '''Function to overwrite the account text file with the current account
        #    details. Account number, pin number, balance and interest (in that
        #    precise order) are the first four lines - there are then two lines
        #    per transaction as outlined in the above 'get_transaction_string'
        #    function.'''
